Exit status always zero in KSH from Oracle Scheduler


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting Exit status always zero in KSH from Oracle Scheduler
# 1  
Old 06-09-2010
Exit status always zero in KSH from Oracle Scheduler

Hi,
Running Oracle Scheduler 11g2 on an AIX 6.01.
I want to run a shell script (called "external program" in Oracle terminology) which executes some commands and react on the outcome using the exit status $?. For example a "cat thisfiledoesnotexist" and then get the $? which should be not zero. My script operates perfectly when ran from the command line, but when ran from Oracle Scheduler the $? is always zero...Smilie
My script has she-bang ksh
What is happening? Why is jobcc (see script below) always zero after exit13.sh finisched and ... can I work around this? I have looked for traps, coprocess, ...?

The main script called by Oracle Scheduler:
Code:
#!/bin/ksh
ofl="/var/stpweb/spool/stpjw02_"`date +"%Y%m%d%H%M%S"`".log"
jobcc=0
echo "Script 08-06-2010 08:14:47" >>$ofl
echo "WHOAMI="`whoami` >>$ofl
echo "Start /home/app/axi/stpweb/exec/sh/exit13.sh" >>$ofl
/home/app/axi/stpweb/exec/sh/exit13.sh
jobcc=${?}
echo "THE EXIT CODE IS: ${jobcc}" >>$ofl
exit ${jobcc}

The exit13.sh:
Code:
#!/bin/ksh
exit 13

Moderator's Comments:
Mod Comment Use code tags please, ty.

Last edited by zaxxon; 06-09-2010 at 09:41 AM.. Reason: code tags
# 2  
Old 06-09-2010
Code:
jobcc=${?}
echo "THE EXIT CODE IS: ${jobcc}" >>$ofl

if [[ $? ]]
then 
echo "the exit code is : ${jobcc}" >> $ofl

try this it might work.. for u looking for
This User Gave Thanks to dazdseg For This Post:
# 3  
Old 06-10-2010
Hello dazdseg,

That does not work either. I even tried setting a "trap ErrorHandler ERR" and even that error-trap does not fire after a "cat nonexistingfile". This is so weird...

---------- Post updated 2010-06-10 at 12:46 PM ---------- Previous update was 2010-06-09 at 05:19 PM ----------

It's not solved but the work around has been found in using an Oracle Scheduler Agent.
# 4  
Old 06-10-2010
can you explain me in lil more details what ru trying to do. i think i am not able to understand what exactly ur trying to do.
# 5  
Old 06-10-2010
We were trying to get Oracle Scheduler to run on AIX6. But in the ksh scripts that were ran thru Oracle Scheduler the exit status of a program or other script was not passed back into the $?. In fact: if we checked the $? is was set to 0 in some miraculous way. We were trying to figure out how to avoid that, e.g. by starting another process that would not be messed up by the Oracle Scheduler (as we think is what is happening).
But we have found a work around and now focus on getting our work ready in time ;-)
# 6  
Old 06-10-2010
umm let me know if u need any help. i will try too help as much as i can.
# 7  
Old 06-10-2010
Thanks dazdseg. I will post again if necessary.
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Want to get the exit status

Hi All, I am trying to create a zip file with all the txt files(these are in large number) in the current directory. I am able to do this operation sucessfully. After this i want to get the status of the tar command executed and do accordingly. When i am trying with the below code, the status... (3 Replies)
Discussion started by: paddu
3 Replies

2. Shell Programming and Scripting

Exit status of the ksh Script

Hi Im trying to write a script that will archive some file using java program.Below is the part of the script that I use and my problem is that the script always return with status 0.Below is part of my script(end part) purge.ksh echo "No of files before tar :... (4 Replies)
Discussion started by: saachinsiva
4 Replies

3. Shell Programming and Scripting

Exit Status

I have a shell script (#!/bin/sh) that interacts with Appworx and Banner Admin. In my script I want to check the exit status of awrun before continuing. awrun can run for 10 seconds or it can run for over a minute. So my question is, will it go through my if statement before awrun may even be... (2 Replies)
Discussion started by: smkremer
2 Replies

4. Shell Programming and Scripting

exit status from ksh script exec from java using runtime

how do i get the exit status from a ksh or perl script executed in a java program using Runtime? (1 Reply)
Discussion started by: twk
1 Replies

5. Shell Programming and Scripting

ksh script not working if triggered by scheduler

I have a script that works well if i execute manually using informix user. However, it does not execute properly if triggered using the scheduler (ESP). This is the partial part where it doesn't work. i added some tracing but i can't figure it out. #!/bin/ksh let db_is_up=0... (6 Replies)
Discussion started by: tungaw2004
6 Replies

6. Shell Programming and Scripting

HELP WITH .ksh script converting the exit status

Hi Can someone help me please? In a standard UNIX .ksh script, if you have the exit status..say 5...what line do you have to enter into the script for this number to be automatically converted to its actual exit reason by looking up the exit status file...wherever that is? thanks angus (1 Reply)
Discussion started by: angusyoung
1 Replies

7. Shell Programming and Scripting

Exit status

I'm preparing for exam and one of exams is to write own test command... I wonder if in unix is a command which just returns exit code you specify.. I know I can easily write a function like this: exStatus() { return $1 } -> my question is rather theoretical thank you! (9 Replies)
Discussion started by: MartyIX
9 Replies

8. Shell Programming and Scripting

How to get the exit status

Hi all, I'm running a program which return 1 upon success. But when encounters problem shell return 's '1' . How to differentiate between them the shell return value and script return value. Ex. function fn return '1' if executed successfully and '0' if failed. But when if shell encounters... (1 Reply)
Discussion started by: yhacks
1 Replies

9. Shell Programming and Scripting

$HOME Not Getting Set for Oracle Scheduler Script at Runtime

We are researching the possibility of using Oracle 10g Scheduler on Solaris 10 to launch scripts at our site, and the script that I am testing does not get $HOME (and other environment variables) set correctly. Here is the Korn shell script (show_info.ksh): #!/usr/bin/ksh id env | sort Here... (4 Replies)
Discussion started by: shew01
4 Replies

10. Shell Programming and Scripting

Need Clean Exit from KSH Status Loop

I have a ksh loop that monitors front panel key postitions. I need a keystroke or something to break out of the loop without exiting the script. Code is: #!/bin/ksh while true do POST=$(./keystat2 | nawk '{print $1}') if ]; then ... (2 Replies)
Discussion started by: ScottKe
2 Replies
Login or Register to Ask a Question